package com.ruoyi.sim.domain.vo;

import com.ruoyi.sim.constant.CommConst;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

public class SimSocketVo {

    /**
     * ip v4.
     */
    private String ip;
    /**
     * port.
     */
    private Integer port;

    public SimSocketVo(String ip, Integer port) {
        this.ip = ip;
        this.port = port;
    }

    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public Integer getPort() {
        return port;
    }

    public void setPort(Integer port) {
        this.port = port;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this)
                .append("ip", ip)
                .append("port", port)
                .toString();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o == null || getClass() != o.getClass()) return false;

        SimSocketVo that = (SimSocketVo) o;

        return new EqualsBuilder().append(ip, that.ip).append(port, that.port).isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37).append(ip).append(port).toHashCode();
    }

    public String toKey() {
        if (StringUtils.isBlank(ip)) {
            throw new IllegalArgumentException("ip error");
        }
        if (port == null || port <= CommConst.PORT_MIN || port >= CommConst.PORT_MAX) {
            throw new IllegalArgumentException("port error");
        }
        return ip + ":" + port;
    }
}
